<?xml version="1.0" encoding="UTF-8" ?>
	<!-- ================================================================ -->
	<!--     copyright 2000 by voxeo corporation. (see LGPL.txt)          -->
	<!--                                                                  -->
	<!--                       Version 1.0c                               -->
	<!-- ================================================================ -->

<!-- ================================================== -->
<!-- This script is invoked to start a new call.        -->
<!--                                                    -->
<!-- Variables passed to this routine:                  -->
<!--     GroupToCall - Identifies a list of phone       -->
<!--         numbers to call based on a DB access       -->
<!--     ListenSessionID - destination for call events  -->
<!-- ================================================== -->

<CFIF ParameterExists(LC)>
	<cfset LC = #IncrementValue(LC)#>
<cfelse>
	<cfset LC = "1">
</cfif>

<CFIF ParameterExists(LastOrder)>
	<cfset SearchOrder = LastOrder>
<cfelse>
	<cfset SearchOrder = "">
</cfif>

<CFIF ParameterExists(LastNum)>
	<cfset SearchNum = LastNum>
<cfelse>
	<cfset SearchNum = "">
</cfif>

<cfquery name="GetPhone"
         datasource="CallCenter"
         maxrows=1
         dbtype="ODBC">
	SELECT
		GroupTransfers.order AS ThisOrder, 
		GroupTransfers.phone AS NumToCall,
		GroupTransfers.callMaxTime AS MaxTime
	FROM         GroupTransfers 
	WHERE       (GroupTransfers.group = '#GroupToCall#') 
		AND 	(GroupTransfers.order = '#SearchOrder#')
		AND 	(GroupTransfers.phone > '#SearchNum#')
	ORDER BY  GroupTransfers.group, GroupTransfers.order, GroupTransfers.phone
</cfquery>

<CFIF GetPhone.RecordCount is 0>
	<cfquery name="GetPhone"
	         datasource="CallCenter"
	         maxrows=1
	         dbtype="ODBC">
		SELECT
			GroupTransfers.order AS ThisOrder, 
			GroupTransfers.phone AS NumToCall,
			GroupTransfers.callMaxTime AS MaxTime
		FROM         GroupTransfers 
		WHERE       (GroupTransfers.group = '#GroupToCall#') 
			AND 	(GroupTransfers.order > '#SearchOrder#')
		ORDER BY  GroupTransfers.group, GroupTransfers.order, GroupTransfers.phone
	</cfquery>
</CFIF>


<callXML>

<block label="main">

<cfoutput>
	<assign var="LC" value="#LC#"/>
	
	<simline value="cc_cr_CallGroup.cfm[#LC#]: In main block LC = #LC#" />
	<simline value="cc_cr_CallGroup.cfm[#LC#]: In main block CF SearchOrder = #SearchOrder#" />
	<simline value="cc_cr_CallGroup.cfm[#LC#]: In main block CF SearchNum = #SearchNum#" />
	
	<assign var="ListenSessionID" value="#ListenSessionID#"/>
	
	<simline value="cc_cr_CallGroup.cfm[#LC#]: In main block ListenSessionID = #ListenSessionID#" />
</cfoutput>
<CFIF GetPhone.RecordCount is 0>
<cfoutput>
	<simline value="cc_cr_CallGroup.cfm[#LC#]: No more records, sendevent NoAgents to $listenSessionID;" />
	
	<sendevent value="NoAgents"
			session="$ListenSessionID;"/>
</cfoutput>
<CFELSE>

<cfoutput query="GetPhone">

	<assign var="LastOrder" value="#ThisOrder#"/>
	<assign var="GroupToCall" value="#GroupToCall#"/>
	<assign var="LastNum" value="#NumToCall#"/>

	<simline value="cc_cr_CallGroup.cfm[#LC#]: In main block LastOrder = #ThisOrder#" />
	<simline value="cc_cr_CallGroup.cfm[#LC#]: In main block GroupToCall = #GroupToCall#" />
	<simline value="cc_cr_CallGroup.cfm[#LC#]: In main block LastNum = #NumToCall#" />
	
	 <block label="call">
  
  <!-- ===================================== -->
  <!-- Dial the phone number that was        -->
  <!-- returned from the database.           -->
  <!-- ===================================== -->

		<simline value="cc_cr_CallGroup.cfm[#LC#]: In call block just before call #NumToCall#" />
		
		<call value="#NumToCall#"
			maxtime="#MaxTime#s"/>
			
		<simline value="cc_cr_CallGroup.cfm[#LC#]: In call block just after call #NumToCall#" />

		<!-- ===================================== -->
		<!-- Event handlers for all possible       -->
		<!-- outcomes of placing the call.         -->
		<!-- The only one passed back to the       -->
		<!-- initial session (ListenSessionID) is  -->
		<!-- <onanswer type="person">, all others  -->
		<!-- restart this cfm file to get and call -->
		<!-- the next phone number for the Group.  -->
		<!--                                       -->
		<!-- <onAnswer type="person"> generates a  -->
		<!-- "Success" event in ListenSessionID.   -->
		<!-- ===================================== -->
                
		<onAnswer>
		
			<simline value="cc_cr_CallGroup.cfm[#LC#]: In onAnswer just before send event Success to $listenSessionID;" />
			
			<sendevent value="Success"
				session="$ListenSessionID;"/>
			
<CFSET MessageFile="cc_Voice/cc_NewCaller.wav">
<CFSET MessageText="Please hold for a new caller.">
<CFINCLUDE template="cc_cm_PlayMessage.cfm">

			<wait value="Unlimited"/>                      
		</onAnswer>
		
		<onError>
			<simline value="cc_cr_CallGroup.cfm[#LC#]: In onError" />
		</onError>
		
		<onCallFailure>
			<simline value="cc_cr_CallGroup.cfm[#LC#]: In onCallFailure" />
		</onCallFailure>
		
		<onMaxTime>
			<simline value="cc_cr_CallGroup.cfm[#LC#]: In onMaxTime" />
		</onMaxTime>

		<simline value="cc_cr_CallGroup.cfm[#LC#]: Before end of call block just before run cc_cr_CallGroup.cfm" />
  
	<!-- ============================================================ -->
	<!-- Attempt to establish a new call to the next Group set phone. -->
	<!-- ============================================================ -->
	
		<run value="cc_cr_CallGroup.cfm"
			submit="*"
			method="get" cache="no" />
			
	<simline value="cc_cr_CallGroup.cfm[#LC#]: Just before end of call block" />
	
	</block>
		
</cfoutput>
</CFIF>
<cfoutput>		
	<!-- ============================================================ -->
	<!-- End of main block                                            -->
	<!-- ============================================================ -->
		
	<simline value="cc_cr_CallGroup.cfm[#LC#]: Just before end of main block" />
	
</cfoutput>		
	</block>

</callXML>
