<?xml version="1.0" encoding="UTF-8" ?>
	<!-- ================================================================ -->
	<!--     copyright 2000 by voxeo corporation. (see LGPL.txt)          -->
	<!--                                                                  -->
	<!--                       Version 1.0c                               -->
	<!-- ================================================================ -->

			<!-- ============================================================ -->
			<!-- This CallXML file is executed from the cc_Answer.xml file.   -->
			<!-- ============================================================ -->

<callxml>

	<block>

			<!-- ============================================================ -->
			<!-- Play hold message to the caller.                             -->
			<!-- ============================================================ -->

<CFSET MessageFile="cc_Voice/cc_Hold.wav">
<CFSET MessageText="Please hold while we connect you to an agent.">
<CFINCLUDE template="cc_cm_PlayMessage.cfm">
		
<CFIF ParameterExists(URL.CalledRecordKey)>
	<cfset RecordKey = '#URL.CalledRecordKey#' >
<cfelse>
	<CFIF ParameterExists(URL.DebugFlag)>
		<text>
			Session Called ID not passed as called record key.
			Setting record key to default value.
		</text>
	</CFIF>
	<cfset RecordKey = 'Default' >
</CFIF>

<CFQUERY name="GetRecord" dataSource="CallCenter" maxRows=1>
	SELECT 
		CalledGroups.CalledID AS CalledKey, 
		CalledGroups.group AS FoundGroup 
	FROM CalledGroups
	WHERE CalledGroups.CalledID = '#RecordKey#'
</CFQUERY>

<cfif GetRecord.RecordCount IS "0">
<CFIF ParameterExists(URL.DebugFlag)>
	<CFOUTPUT>
		<text>
			Session Search for Record key value #RecordKey#, returned 0 records.
			Setting record key to default value.
		</text>
	</cfoutput>
</CFIF>
	<cfset RecordKey = 'Default' >
	<CFQUERY name="GetRecord" dataSource="CallCenter" maxRows=1>
		SELECT 
			CalledGroups.CalledID AS CalledKey, 
			CalledGroups.group AS FoundGroup 
		FROM CalledGroups
		WHERE CalledGroups.CalledID = '#RecordKey#'
	</CFQUERY>

</cfif>

<cfif GetRecord.RecordCount IS "0">
<CFIF ParameterExists(URL.DebugFlag)>
	<CFOUTPUT>
		<text>
			Session Search for Record key value #RecordKey#, returned 0 records.
			Terminating call, now.
		</text>
	</CFOUTPUT>
</CFIF>
	
			
<CFSET MessageFile="cc_Voice/cc_NoAgents.wav">
<CFSET MessageText="No agents are currently available to service your call.">
<CFINCLUDE template="cc_cm_PlayMessage.cfm">

<CFSET MessageFile="cc_Voice/cc_HangUp.wav">
<CFSET MessageText="Please hang up and try your call again later.">
<CFINCLUDE template="cc_cm_PlayMessage.cfm">

	<hangup/>
<cfelse>

	<cfoutput query="GetRecord">

			<!-- ============================================================ -->
			<!-- Set up some variables for the new call session.              -->
			<!--                                                              -->
			<!--     ListenSessionID - Used to send events to this session    -->
			<!--     GroupToCall - Group set to find transfer phone numbers   -->
			<!--     AnswerText - Whisper message played to destination       -->
			<!--         before caller is connected (to announce the caller)  -->
			<!-- ============================================================ -->

		<assign var="ListenSessionID" value="$session.ID;"/>
		<assign var="GroupToCall" value="#FoundGroup#"/>
		<assign var="LC" value="0"/>
		
<CFSET MessageFile="cc_Voice/cc_Group.wav">
<CFSET MessageText="Call Center Transfer Group is,">
<CFINCLUDE template="cc_cm_PlayMessage.cfm">

		<text>
			#FoundGroup#.
		</text>
			<!-- ============================================================ -->
			<!-- Attempt to establish a new call to a Group set phone.        -->
			<!-- ============================================================ -->

		<run value="cc_cr_CallGroup.cfm"
			submit="*"
			method="get"
			var="NewCallSessionID" cache="no" />
		
			<!-- ============================================================ -->
			<!-- Start a block to play music while listening for events.      -->
			<!-- ============================================================ -->

		<block label="Hold Music"
			repeat="3">
			
			<!-- ============================================================ -->
			<!-- Play hold music.                                             -->
			<!-- ============================================================ -->

			<playaudio format="audio/wav" value="cc_Voice/cc_HoldMusic.wav" cache="no" />
				
			<!-- ============================================================ -->
			<!-- Listen for an event to be fired while the music plays.       -->
			<!-- ============================================================ -->
				
			<!-- ============================================================ -->
			<!-- Listen for "Success"                                         -->
			<!-- Announce the connection and conference to the other session. -->
			<!-- ============================================================ -->
			
			<onexternalevent value="Success">
			
<CFSET MessageFile="cc_Voice/cc_Connecting.wav">
<CFSET MessageText="Your call is connecting to an agent, now.">
<CFINCLUDE template="cc_cm_PlayMessage.cfm">

				<conference targetsessions="$session.EventsenderID;"/>
				<hangup/>   
			</onexternalevent>	 
		
				
			<!-- ============================================================ -->
			<!-- Listen for "NoAgents"                                         -->
			<!-- Announce the connection and conference to the other session. -->
			<!-- ============================================================ -->
			
			<onexternalevent value="NoAgents">
			
<CFSET MessageFile="cc_Voice/cc_NoAgents.wav">
<CFSET MessageText="No agents are currently available to service your call.">
<CFINCLUDE template="cc_cm_PlayMessage.cfm">

<CFSET MessageFile="cc_Voice/cc_HangUp.wav">
<CFSET MessageText="Please hang up and try your call again later.">
<CFINCLUDE template="cc_cm_PlayMessage.cfm">

				<hangup/>
			</onexternalevent>	 
			
			<!-- ============================================================ -->
			<!-- End of "Hold Music" block                                    -->
			<!-- ============================================================ -->

		</block>
	</CFOUTPUT>
</cfif>

			<!-- ============================================================ -->
			<!-- End of main block                                            -->
			<!-- ============================================================ -->

	</block>

</callxml>
